<template>
  <div class="column is-4 is-flex">
    <mt-box padding="0">
      <article class="mt-messages" :class="{ 'with-action': !contact.lu || !contact.traite }">
        <header>
          <h1>{{ contact.objet }}</h1>
          <b-icon v-if="contact.lu" icon="eye" size="is-small"></b-icon>
          <b-icon v-if="contact.traite" icon="check" size="is-small"></b-icon>
        </header>

        <output>{{ contact.message }}</output>

        <footer>
          <div class="mt-groupe-contact">
            <b-icon icon="account-circle"></b-icon>
            <div class="mt-nom-prenom-time">
              <p>
                <b class="is-uppercase">{{ contact.nom }}</b> {{ contact.prenom }}
              </p>
              <time>
                le <b>{{ jourMoisAnnee }}</b> à <small>{{ heureMinutes }}</small>
              </time>
            </div>
          </div>

          <div class="mt-groupe-mail">
            <a :href="`mailto:${contact.email}`"
              ><small>{{ contact.email }}</small></a
            >
            <b-button
              class="mt-button is-size-7 mt-button-ultra-fin"
              type="is-secondary"
              icon-left="content-copy"
              title="copier l'adresse email"
              @click="copy"
            >
            </b-button>
          </div>
        </footer>
      </article>
      <aside v-if="!contact.lu || !contact.traite">
        <b-button
          v-if="!contact.lu"
          class="mt-button is-size-7 mt-button-fin"
          type="is-secondary"
          icon-left="eye"
          @click="lireMessage"
          >lue
        </b-button>
        <b-button
          v-if="!contact.traite"
          class="mt-button is-size-7 mt-button-fin"
          type="is-secondary"
          icon-left="check"
          @click="traiterMessage"
          >traité
        </b-button>
      </aside>
    </mt-box>
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import MtBox from '~/components/base/box';

export default {
  name: 'MtVisuContact',
  components: { MtBox },
  props: {
    contact: {
      type: Object,
      default: () => ({}),
    },
  },
  computed: {
    jourMoisAnnee() {
      return DateTime.fromISO(this.contact.dateCreation)
        .setLocale('fr')
        .toFormat('dd/MM/yyyy');
    },
    heureMinutes() {
      return DateTime.fromISO(this.contact.dateCreation)
        .setLocale('fr')
        .toFormat('HH:mm');
    },
  },
  methods: {
    copy() {
      this.$copyText(this.contact.email).then(
        () => {
          this.$buefy.toast.open({
            message: `"${this.contact.email}" copié dans le presse papier`,
            type: 'is-success',
          });
        },
        () => {
          this.$buefy.toast.open({
            message: `Impossible de copié dans le presse papier`,
            type: 'is-danger',
          });
        },
      );
    },
    lireMessage() {
      this.$emit('lire-message', this.contact);
    },
    traiterMessage() {
      this.$emit('traiter-message', this.contact);
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
/deep/ .mt-box {
  margin: 0.5rem;
  display: flex;
  flex-direction: column;
}
.mt-messages {
  display: flex;
  flex-direction: column;
  flex-grow: 1;
  padding: 1rem 2rem;

  &.with-action {
    border-bottom: 1px solid #eee;
  }

  header {
    display: flex;
    align-items: center;

    h1 {
      flex-grow: 1;
    }

    /deep/ .icon {
      color: $primary;
      margin: 0 0.25em;
    }
  }

  h1 {
    font-weight: 300;
    color: $primary;
    font-size: 1.5rem;
    margin-bottom: 0.5em;
  }

  output {
    flex-grow: 1;
    text-align: justify;
    word-break: break-word;
    margin-bottom: 1rem;
    white-space: pre-wrap;
    padding-bottom: 1rem;
  }

  footer {
    color: $brown-grey;

    .mt-nom-prenom-time {
      display: flex;
      flex-direction: column;
    }

    time {
      font-size: 0.75rem;
      line-height: 1;
    }

    .mt-groupe-contact {
      display: flex;
      align-items: center;

      /deep/ .icon {
        color: #aaa;
        margin-right: 0.5rem;
      }
    }

    .mt-groupe-mail {
      display: flex;
      justify-content: space-between;
      margin: 0.3em 0 0.3em 2rem;

      a {
        color: #aaa;
        text-decoration: underline;
      }
      a:hover {
        color: black;
      }
    }
  }
}
.mt-button-ultra-fin {
  padding: 0 1em;
}

/deep/ .mdi-12px:before {
  font-size: 12px;
}
aside {
  margin: 1rem 2rem;
}
</style>
